GLOBAL.setmetatable(
	env,
	{
		__index = function(t, k)
			return GLOBAL.rawget(GLOBAL, k)
		end
	}
)

GLOBAL.QUICK_PLANT_HOTKEY = GetModConfigData("hotkey")

local tree_seeds = {
	{seed = "pinecone", tree = "evergreen_short"},
	{seed = "acorn", tree = "deciduoustree"},
	{seed = "coconut", tree = "palmtree_short"},
	{seed = "jungletreeseed", tree = "jungletree_short"},
	{seed = "burr", tree = "rainforesttree_short"},
	{seed = "cork", tree = "clawpalmtree"},
	{seed = "teatree_nut", tree = "teatree"}
}

local dug_plants = {
	{root = "dug_sapling", plant = "sapling"},
	{root = "dug_grass", plant = "grass"},
	{root = "dug_berrybush", plant = "berrybush"},
	{root = "dug_berrybush2", plant = "berrybush2"},
	{root = "dug_bambootree", plant = "bambootree"},
	{root = "dug_bush_vine", plant = "bush_vine"},
	{root = "dug_coffeebush", plant = "coffeebush"},
	{root = "dug_elephantcactus", plant = "elephantcactus_active"},
	{root = "dug_nettle", plant = "nettle"},
	{root = "dug_berrybush_juicy", plant = "berrybush_juicy"},
	{root = "bullkelp_root", plant = "bullkelp_plant"},
	{root = "dug_rock_avocado_bush", plant = "rock_avocado_bush"},
	{root = "rock_avocado_fruit_sprout", plant = "rock_avocado_bush"},
	{root = "dug_reeds", plant = "reeds"}
}

local function FinDBeacon(it, target)
	local pt = it:GetPosition()
	local items = TheSim:FindEntities(pt.x, pt.y, pt.z, 1, {}, {"INLIMBO", "NOCLICK", "DECOR", "FX"})
	for _, item in ipairs(items) do
		if item and item.prefab == target then
			return item
		end
	end
	return it
end

local function DoPlant()
	local player = GLOBAL.GetPlayer()
	local pt = player:GetPosition()
	local items = TheSim:FindEntities(pt.x, pt.y, pt.z, 20, {}, {"INLIMBO", "NOCLICK", "DECOR", "FX"})
	for _, item in ipairs(items) do
		if item then
			for _, tree_seed in ipairs(tree_seeds) do
				if item.prefab == tree_seed.seed then
					local amount = 1
					if item.components and item.components.stackable then
						amount = item.components.stackable:StackSize()
					end
					for i = 1, amount do
						local planted = SpawnPrefab(tree_seed.tree)
						planted.Transform:SetPosition(item.Transform:GetWorldPosition())
						planted:growfromseed()
					end
					item:Remove()
				end
			end

			for _, dug_plant in ipairs(dug_plants) do
				if item.prefab == dug_plant.root then
					local amount = 1
					if item.components and item.components.stackable then
						amount = item.components.stackable:StackSize()
					end
					local beacon = FinDBeacon(item, dug_plant.plant)
					for i = 1, amount do
						local planted = SpawnPrefab(dug_plant.plant)
						planted.Transform:SetPosition(beacon.Transform:GetWorldPosition())
					end
					item:Remove()
				end
			end
		end
	end
end

GLOBAL.TheInput:AddKeyUpHandler(GLOBAL.QUICK_PLANT_HOTKEY, DoPlant)
